///
/// @file
/// @brief cmeta::ElementCollection
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "ElementCollection.hpp"
#include <algorithm>

namespace cmeta {

//
// ftHg RXgN^
//
ElementCollection::ElementCollection()
{
	// do nothing.
}

//
// fXgN^
//
ElementCollection::~ElementCollection()	// nothrow
{
	std::for_each(mElements.begin(), mElements.end(), [](ElementItem& iItem) {
		delete iItem.element;
	});
}

//
// vfǉB
//
void ElementCollection::add(Element* iElement, const Scope iScope, const Location& iLocation)
{
	auto aIt = std::find_if(mLocations.begin(), mLocations.end(), [iLocation](const std::shared_ptr<Location>& iCur) {
		return iCur->getPath() == iLocation.getPath();
	});
	if (aIt != mLocations.end()) {
		// o^ς݂̃P[Vɔzu
		ElementItem aItem = { iElement, iScope, aIt->get() };
		mElements.push_back(aItem);
	} else {
		// VP[Vɔzu
		auto aLocation = std::make_shared<Location>(iLocation);
		mLocations.push_back(aLocation);
		
		ElementItem aItem = { iElement, iScope, aLocation.get() };
		mElements.push_back(aItem);
	}
}

};
