///
/// @file
/// @brief cmeta::Emumeration
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Enumeration.hpp"

namespace cmeta {

//
// RXgN^
//
Emumeration::Emumeration(const std::string& iName):Type(iName)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Emumeration::Emumeration(const Emumeration& iSource):Type(iSource), mConstants(iSource.mConstants)
{
	// do nothing.
}

//
// fXgN^
//
Emumeration::~Emumeration()	// nothrow
{
	// do nothing.
}

//
// 񋓒lǉB
//
void Emumeration::add(const EnumerationConstant& iConstant)
{
	mConstants.push_back(iConstant);
}

//
// oϐB
//
void Emumeration::swap(Emumeration& ioSource)	// nothrow
{
	Type::swap(ioSource);
	std::swap(mConstants, ioSource.mConstants);
}

//
// Rs[Zq
//
Emumeration& Emumeration::operator=(const Emumeration& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
