///
/// @file
/// @brief cmeta::EnumerationConstant
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "EnumerationConstant.hpp"

namespace cmeta {

//
// RXgN^
//
EnumerationConstant::EnumerationConstant(const std::string& iName, const std::string& iValue):
	Element(iName), mValue(iValue)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
EnumerationConstant::EnumerationConstant(const EnumerationConstant& iSource):
	Element(iSource), mValue(iSource.mValue)
{
	// do nothing.
}

//
// fXgN^
//
EnumerationConstant::~EnumerationConstant()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void EnumerationConstant::swap(EnumerationConstant& ioSource)	// nothrow
{
	Element::swap(ioSource);
	std::swap(mValue, ioSource.mValue);
}

//
// Rs[Zq
//
EnumerationConstant& EnumerationConstant::operator=(const EnumerationConstant& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
