///
/// @file
/// @brief cmeta::Function
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Function.hpp"
#include <cassert>

namespace cmeta {

//
// RXgN^
//
Function::Function(const std::string& iName, const Type* iType):Element(iName), mImpl((assert(iType != nullptr), iType))
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Function::Function(const Function& iSource):Element(iSource), mImpl(iSource.mImpl)
{
	// do nothing.
}

//
// fXgN^
//
Function::~Function()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void Function::swap(Function& ioSource)	// nothrow
{
	Element::swap(ioSource);
	mImpl.swap(ioSource.mImpl);
}

//
// Rs[Zq
//
Function& Function::operator=(const Function& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

//
// ߂ľ^擾B
//
const Type& Function::getTypeImpl() const
{
	return mImpl.getType();
}

//
// Xg̐擪擾B
//
IFunction::const_iterator Function::beginImpl() const
{
	return mImpl.begin();
}

//
// Xg̖擾B
//
IFunction::const_iterator Function::endImpl() const
{
	return mImpl.end();
}

};
