///
/// @file
/// @brief cmeta::FunctionPointer
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "FunctionPointer.hpp"
#include <cassert>

namespace cmeta {

//
// RXgN^
//
FunctionPointer::FunctionPointer(const std::string& iName, const Type* iType):Type(iName), mImpl((assert(iType != nullptr), iType))
{
	// do nothing.
}

//
// Rs[ RXgN^
//
FunctionPointer::FunctionPointer(const FunctionPointer& iSource):Type(iSource), mImpl(iSource.mImpl)
{
	// do nothing.
}

//
// fXgN^
//
FunctionPointer::~FunctionPointer()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void FunctionPointer::swap(FunctionPointer& ioSource)	// nothrow
{
	Element::swap(ioSource);
	mImpl.swap(ioSource.mImpl);
}

//
// Rs[Zq
//
FunctionPointer& FunctionPointer::operator=(const FunctionPointer& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

//
// ߂ľ^擾B
//
const Type& FunctionPointer::getTypeImpl() const
{
	return mImpl.getType();
}

//
// Xg̐擪擾B
//
IFunction::const_iterator FunctionPointer::beginImpl() const
{
	return mImpl.begin();
}

//
// Xg̖擾B
//
IFunction::const_iterator FunctionPointer::endImpl() const
{
	return mImpl.end();
}

};
