///
/// @file
/// @brief cmeta::Macro
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Macro.hpp"
#include <regex>

namespace cmeta {

//
// RXgN^
//
Macro::Macro(const std::string& iName):Element(iName)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Macro::Macro(const Macro& iSource):Element(iSource), mBody(iSource.mBody)
{
	// do nothing.
}

//
// fXgN^
//
Macro::~Macro()	// nothrow
{
	// do nothing.
}

//
// }N`̒u敶 1 sǉB
//
void Macro::addBody(const std::string& iLine)
{
	std::regex aRegex("[\\r|\\n]");
	std::smatch aMatch;
	if (std::regex_search(iLine.cbegin(), iLine.cend(), aMatch, aRegex)) {
		mBody.append(iLine.cbegin(), aMatch[0].first);
	} else {
		mBody.append(iLine);
	}
}

//
// oϐB
//
void Macro::swap(Macro& ioSource)	// nothrow
{
	Element::swap(ioSource);
	std::swap(mBody, ioSource.mBody);
}

//
// Rs[Zq
//
Macro& Macro::operator=(const Macro& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
