///
/// @file
/// @brief cmeta::MacroFunction
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "MacroFunction.hpp"

namespace cmeta {

//
// RXgN^
//
MacroFunction::MacroFunction(const std::string& iName):Macro(iName)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
MacroFunction::MacroFunction(const MacroFunction& iSource):Macro(iSource), mArguments(iSource.mArguments)
{
	// do nothing.
}

//
// fXgN^
//
MacroFunction::~MacroFunction()	// nothrow
{
	// do nothing.
}

//
// }N`̉ǉB
//
void MacroFunction::addArgument(const std::string& iArgument)
{
	mArguments.push_back(iArgument);
}

//
// oϐB
//
void MacroFunction::swap(MacroFunction& ioSource)	// nothrow
{
	Macro::swap(ioSource);
	std::swap(mArguments, ioSource.mArguments);
}

//
// Rs[Zq
//
MacroFunction& MacroFunction::operator=(const MacroFunction& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
