///
/// @file
/// @brief cmeta::Pointer
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Pointer.hpp"
#include <cassert>

namespace cmeta {

//
// RXgN^
//
Pointer::Pointer(const std::string& iName, const Type* iType):Type(iName), mType((assert(iType != nullptr), iType))
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Pointer::Pointer(const Pointer& iSource):Type(iSource), mType(iSource.mType)
{
	// do nothing.
}

//
// fXgN^
//
Pointer::~Pointer()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void Pointer::swap(Pointer& ioSource)	// nothrow
{
	Type::swap(ioSource);
	std::swap(mType, ioSource.mType);
}

//
// Rs[Zq
//
Pointer& Pointer::operator=(const Pointer& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
