///
/// @file
/// @brief cmeta::PrimitiveFunction
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "PrimitiveFunction.hpp"
#include <cassert>

namespace cmeta {

//
// RXgN^
//
PrimitiveFunction::PrimitiveFunction(const Type* iType):mType((assert(iType != nullptr), iType))
{
	// do nothing.
}

//
// Rs[ RXgN^
//
PrimitiveFunction::PrimitiveFunction(const PrimitiveFunction& iSource):mType(iSource.mType), mArguments(iSource.mArguments)
{
	// do nothing.
}

//
// fXgN^
//
PrimitiveFunction::~PrimitiveFunction()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void PrimitiveFunction::swap(PrimitiveFunction& ioSource)	// nothrow
{
	std::swap(mType, ioSource.mType);
	std::swap(mArguments, ioSource.mArguments);
}

//
// Rs[Zq
//
PrimitiveFunction& PrimitiveFunction::operator=(const PrimitiveFunction& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

//
// ߂ľ^擾B
//
const Type& PrimitiveFunction::getTypeImpl() const
{
	return *mType;
}

//
// Xg̐擪擾B
//
IFunction::const_iterator PrimitiveFunction::beginImpl() const
{
	return mArguments.begin();
}

//
// Xg̖擾B
//
IFunction::const_iterator PrimitiveFunction::endImpl() const
{
	return mArguments.end();
}

};
