///
/// @file
/// @brief cmeta::Structure
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Structure.hpp"

namespace cmeta {

//
// RXgN^
//
Structure::Structure(const std::string& iName):Type(iName)
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Structure::Structure(const Structure& iSource):Type(iSource), mMembers(iSource.mMembers)
{
	// do nothing.
}

//
// fXgN^
//
Structure::~Structure()	// nothrow
{
	// do nothing.
}

//
// oϐǉB
//
void Structure::add(const Variable& iMember)
{
	mMembers.push_back(iMember);
}

//
// oϐB
//
void Structure::swap(Structure& ioSource)	// nothrow
{
	Type::swap(ioSource);
	std::swap(mMembers, ioSource.mMembers);
}

//
// Rs[Zq
//
Structure& Structure::operator=(const Structure& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
