///
/// @file
/// @brief cmeta::Synonym
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Synonym.hpp"
#include <cassert>

namespace cmeta {

//
// RXgN^
//
Synonym::Synonym(const std::string& iName, const Type* iType):Type(iName), mType((assert(iType != nullptr), iType))
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Synonym::Synonym(const Synonym& iSource):Type(iSource), mType(iSource.mType)
{
	// do nothing.
}

//
// fXgN^
//
Synonym::~Synonym()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void Synonym::swap(Synonym& ioSource)	// nothrow
{
	Type::swap(ioSource);
	std::swap(mType, ioSource.mType);
}

//
// Rs[Zq
//
Synonym& Synonym::operator=(const Synonym& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
