///
/// @file
/// @brief cmeta::Variable
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "Variable.hpp"
#include <cassert>

namespace cmeta {

//
// RXgN^
//
Variable::Variable(const std::string& iName, const Type* iType):Element(iName), mType((assert(iType != nullptr), iType))
{
	// do nothing.
}

//
// Rs[ RXgN^
//
Variable::Variable(const Variable& iSource):Element(iSource), mType(iSource.mType)
{
	// do nothing.
}

//
// fXgN^
//
Variable::~Variable()	// nothrow
{
	// do nothing.
}

//
// oϐB
//
void Variable::swap(Variable& ioSource)	// nothrow
{
	Element::swap(ioSource);
	std::swap(mType, ioSource.mType);
}

//
// Rs[Zq
//
Variable& Variable::operator=(const Variable& iSource)
{
	auto aDestination = iSource;
	swap(aDestination);
	
	return *this;
}

};
