///
/// @file
/// @brief cparser::Lexer
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CPARSER_LEXER_HPP_INCLUDED
#define CTOXMI_CPARSER_LEXER_HPP_INCLUDED

#include "LexerItem.hpp"
#include "Token.hpp"
#include <vector>
#include <string>
#include <istream>

namespace cparser {

///
/// ̓NX
///
class Lexer {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iSource ̓Xg[w肷B
	/// @param[in] iBegin ͍ڂ̐擪w肷B
	/// @param[in] iEnd ͍ڂ̖w肷B
	///
	Lexer(std::istream& iSource, const LexerItem* iBegin, const LexerItem* iEnd);
	
	///
	/// fXgN^
	///
	~Lexer();	// nothrow
	
	///
	/// g[N͂B
	///
	/// @return g[NԂB̓Xg[I[ɒBꍇ nullptr ԂB
	///
	const Token* getNextToken();
	
	///
	/// w肳ꂽ܂œ̓Xg[XLbvB
	///
	/// @param[in] iUntil w肷B
	///
	void skip(const char* iUntil);
	
private:
	///
	/// ̓Xg[̏I[𔻕ʂB
	///
	/// @retval true I[ɒBĂB
	/// @retval false I[ɒBĂȂB
	///
	const bool isEndOfStream();
	
	///
	/// ̓Xg[̍s𔻕ʂB
	///
	/// @retval true sɒBĂB
	/// @retval false sɒBĂȂB
	///
	const bool isEndOfLine();
	
	///
	/// CǂݍށB
	///
	void readNextLine();
	
private:
	// Rs[֎~
	Lexer(const Lexer&);
	Lexer& operator=(const Lexer&);
	
private:
	std::istream& mSource;
	std::vector<LexerItem> mItems;
	
	std::uint32_t mLine;
	std::uint32_t mColumn;
	
	std::string mLineBuffer;
	
	Token mLastToken;
};

};

#endif
