///
/// @file
/// @brief cparser::LexerException
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#include "LexerException.hpp"
#include <cstdio>

namespace cparser {

//
// RXgN^
//
LexerException::LexerException(const std::uint32_t iLine, const std::uint32_t iColumn):mLine(iLine), mColumn(iColumn)
{
	std::sprintf(mWhat, "lexer exception (line = %d, column = %d)", mLine, mColumn);
}

//
// fXgN^
//
LexerException::~LexerException()	// nothrow
{
	// do nothing.
}

//
// O𕶎ƂĎ擾B
//
const char* LexerException::what() const
{
	return mWhat;
}

};
