///
/// @file
/// @brief cparser::LexerException
///
/// @author Chiharu
///
/// Copyright (C) 2012-2012 Atelier of Chiharu
///

#ifndef CTOXMI_CPARSER_LEXEREXCEPTION_HPP_INCLUDED
#define CTOXMI_CPARSER_LEXEREXCEPTION_HPP_INCLUDED

#include <exception>
#include <cstdint>

namespace cparser {

///
/// ̓NX
///
class LexerException:
	public std::exception {
	
public:
	///
	/// RXgN^
	///
	/// @param[in] iLine G[sw肷B
	/// @param[in] iColumn G[w肷B
	///
	LexerException(const std::uint32_t iLine, const std::uint32_t iColumn);
	
	///
	/// fXgN^
	///
	virtual ~LexerException();	// nothrow
	
	///
	/// O𕶎ƂĎ擾B
	///
	/// @return OԂB
	///
	virtual const char* what() const;
	
	///
	/// G[s擾B
	///
	/// @return sԍԂB
	///
	const std::uint32_t getLine() const
	{
		return mLine;
	}
	
	///
	/// G[擾B
	///
	/// @return ԍԂB
	///
	const std::uint32_t getColumn() const
	{
		return mColumn;
	}
	
private:
	std::uint32_t mLine;
	std::uint32_t mColumn;
	char mWhat[128];
};

};

#endif
